package ru.redguy.dynamicshop.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import ru.redguy.dynamicshop.api.Database;
import ru.redguy.dynamicshop.api.ShopItem;
import ru.redguy.dynamicshop.gui.ShopGuiSell;

public class AddShopItemCommand extends Command {
    public AddShopItemCommand(@NotNull String name) {
        super(name);
    }

    @Override
    public boolean execute(@NotNull CommandSender sender, @NotNull String commandLabel, @NotNull String[] args) {
        if(!(sender instanceof Player)) return true;
        if(!sender.hasPermission("dynshop.add")) return true;
        if(args.length!=1) return true;
        Database.getInstance().addItem(new ShopItem(((Player) sender).getInventory().getItemInMainHand().clone(),Double.parseDouble(args[0].replace(',','.'))));
        ShopGuiSell.update();
        return true;
    }

    @Override
    public @Nullable String getPermission() {
        return "dynshop.add";
    }
}
