package ru.redguy.dynamicshop.commands;

import com.google.common.collect.Lists;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import ru.redguy.dynamicshop.gui.ShopGuiBuy;
import ru.redguy.dynamicshop.gui.ShopGuiSell;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class ShopCommand extends Command {
    public ShopCommand(@NotNull String name) {
        super(name);
    }

    @Override
    public boolean execute(@NotNull CommandSender sender, @NotNull String commandLabel, @NotNull String[] args) {
        if(args.length!=1) return true;
        if(sender instanceof Player) {
            if(args[0].equals("sell")) {
                ShopGuiSell.open((Player) sender);
            }
            if(args[0].equals("buy")) {
                ShopGuiBuy.open((Player) sender);
            }
        }
        return true;
    }

    @Override
    public @NotNull List<String> tabComplete(@NotNull CommandSender sender, @NotNull String alias, @NotNull String[] args) throws IllegalArgumentException {
        String[] subCommands = {"sell","buy"};
        if(args.length!=1) return Lists.newArrayList();
        return Arrays.stream(subCommands).filter(s -> s.startsWith(args[0])).collect(Collectors.toList());
    }
}
