package ru.redguy.dynamicshop.gui.icons;

import me.filoghost.chestcommands.api.Icon;
import me.filoghost.chestcommands.api.MenuView;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.TextColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import ru.redguy.dynamicshop.DynamicShop;
import ru.redguy.dynamicshop.api.Database;
import ru.redguy.dynamicshop.api.ShopItem;
import ru.redguy.dynamicshop.gui.ShopGuiBuy;
import ru.redguy.dynamicshop.gui.ShopGuiSell;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;

public class ItemIconSell implements Icon {
    private int index;

    public ItemIconSell(int index) {
        this.index = index;
    }

    @Override
    public @Nullable ItemStack render(@NotNull Player player) {
        ShopItem item = Database.getInstance().getItem(index);
        if(item == null) return null;
        ItemStack stack = item.getItem().clone();
        if (stack.getType() == Material.AIR) return null;
        List<Component> lore = new ArrayList<>();
        lore.add(Component.text("Цена: ").color(TextColor.color(255,255,255)).append(Component.text(item.getPrice()).color(TextColor.color(255,100,0))));
        stack.lore(lore);
        return stack;
    }

    @Override
    public void onClick(@NotNull MenuView menuView, @NotNull Player player) {
        ShopItem item = Database.getInstance().getItem(index);
        if(item == null) return;
        if (item.getItem().getType() == Material.AIR) return;
        if(!player.getInventory().containsAtLeast(item.getItem().clone(),item.getItem().clone().getAmount())) return;
        if(item.getPrice()<=1) return;

        player.getInventory().removeItem(item.getItem().clone());
        DynamicShop.getInstance().econ.depositPlayer(player,item.getPrice());
        item.setPrice(round(item.getPrice()-0.1d,2));
        Database.getInstance().setItem(index,item);
        ShopGuiSell.update();
        ShopGuiBuy.update();
    }

    public static double round(double value, int places) {
        if (places < 0) throw new IllegalArgumentException();

        BigDecimal bd = BigDecimal.valueOf(value);
        bd = bd.setScale(places, RoundingMode.HALF_DOWN);
        return bd.doubleValue();
    }
}
